/*SpUpd!_2017.02.07_0000603*/
/*needVer=2017.02.07_0000602*/


insert into usl_cost (id, uslug, ts, cost, dbeg) values(36, 'A18.05.002', 1, 6131.36, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(37, 'A18.05.002', 5, 6131.36, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(38, 'A18.05.002.002', 5, 6131.36, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(39, 'A18.05.002.002', 1, 6131.36, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(40, 'A18.05.002.001', 1, 6437.66, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(41, 'A18.05.002.001', 5, 6437.66, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(42, 'A18.05.002.003', 1, 16913.15, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(43, 'A18.05.011', 1, 6636.99, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(44, 'A18.05.011', 5, 6636.99, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(45, 'A18.05.011.001', 1, 18430.14, '01.01.2017');
@
insert into usl_cost (id, uslug, ts, cost, dbeg) values(46, 'A18.05.003', 1, 17671.59, '01.01.2017');
@
update ksg16_group g set g.mkb='C' where g.mkb='C.';
@
DROP INDEX MTL_ID_ILL;
@
Commit work;
@
CREATE INDEX MTL_ID_ILL ON MTL (ID_ILL);
@

create or alter procedure SET_UR_COST
returns (
    CNT_ERR integer,
    CNT_NULL integer)
as
declare variable P_LPU smallint;
declare variable P_TS smallint;
declare variable P_OPL smallint;
declare variable P_M smallint;
declare variable P_PROF smallint;
declare variable P_KOD_MES varchar(16);
declare variable P_UR smallint;
declare variable P_MID integer;
declare variable NEW_UR integer;
begin
  cnt_err=0;
  cnt_null=0;
  for select r.lpu, r.tip_stac, r.oplat, extract(month from s.out_stac) M, m.pr_oms, m.id, m.kod_mes, coalesce(m.ur_cost,0) from stacion s
  join mtl m on m.id_ill=s.id_ill
  join reports r on r.repn=s.repn
  where r.see1=1 and r.see2=1 and r.oplat in (1,6,7) and m.oplat=r.oplat and s.sum_mek is null
  into :p_lpu, :p_ts, :p_opl, :p_m, :p_prof, :p_mid, :p_kod_mes, :p_ur do
    begin
    new_ur=0;
    if ((p_ts=1) and (p_opl<>6)) then
      begin
      if (character_length(Trim(p_kod_mes))>=12) then
             new_ur=cast(substring(p_kod_mes from 12 for 1) as smallint)+1;
        else new_ur=cast(substring(p_kod_mes from 1 for 1) as smallint)-1;
      end
     else
      begin
      select first 1 iif(coalesce(p2.pgk_m,0)>0,iif(coalesce(l.fed_lpu,0)=1,5,4), iif(coalesce(p2.pgg_m,0)>0,3,1)) urov from planindex p, lpu l
      join plan2month p2 on p2.plan_idx=p.id
      where p.lpu=l.id and p.lpu=:p_lpu and p.oplat=:p_opl and p.ts=:p_ts and p.profile=:p_prof and p2.n_month=:p_m
      into :new_ur;
      end

    if (new_ur=2) then new_ur=1;
    if (new_ur<>p_ur) then
      begin
      if (p_ur=0) then cnt_null=cnt_null+1;
                  else cnt_err=cnt_err+1;
      update mtl m set m.ur_cost=:new_ur where m.id=:p_mid;
      end
    end
  suspend;
end;
@
Commit work;
@
execute procedure set_ur_cost;
@